/**
 * Sensor "ficticio"
 * Demostracin del uso de JButton, JTextField & JLabel
 */

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

public class SensorSwing extends Sensor
                         implements ActionListener {

  private JFrame     frame;
  private JPanel     panel;
  private JButton    button;
  private JTextField editor;
  private JLabel     info;

  private Alarma     alarma;

  /**
   * Constructor
   */

  public SensorSwing() 
  {
    // Ventana (JFrame)
    frame = new JFrame("Medidor del \"grado de alarma\"");
    frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
    frame.setSize(300,100);

    // Panel (JPanel)
    // ...donde se colocan los controles de la interfaz de usuario

    panel = new JPanel(new GridLayout(3, 1));

    // Controles de la interfaz de usuario
    // -----------------------------------

    editor = new JTextField(5);
    info   = new JLabel("Valor actual...", SwingConstants.CENTER);
    button = new JButton("Actualizar");

    // Manejador de eventos asociado al botn
    button.addActionListener(this);

    // Colocar los controles en el panel
    panel.add(editor);
    panel.add(button);
    panel.add(info);
        
    // Botn por defecto
    frame.getRootPane().setDefaultButton(button);

    // Aadir el panel a la ventana
    frame.getContentPane().add(panel);

    // Mostrar la ventana
    frame.setVisible(true);
  }


  /**
   * Alarma asociada
   */

  public void setAlarma (Alarma alarma)
  {
    this.alarma = alarma;
  }

  /**
   * Pulsacin del botn.
   */

  public void actionPerformed(ActionEvent event) 
  {
    setValorActual( Double.parseDouble(editor.getText()) );
    info.setText("Valor actual = " + getValorActual() );

    if (alarma!=null) {
       alarma.comprobar();
    }
  }
}
