/**
 * Alarma luminosa
 * Uso de redefinicin de mtodos y polimorfismo
 *
 * Versin 1: Redefinicin del mtodo comprobar()
 */

public class AlarmaLuminosa extends Alarma
{
  private Bombilla bombilla;


  /**
   * Constructor
   */

  public AlarmaLuminosa (Sensor sensor, Timbre timbre, Bombilla bombilla, double umbral)
  {
    super(sensor,timbre,umbral);

    this.bombilla = bombilla;
  }

  /**
   * Redefinicin del mtodo comprobar
   *  - Acceso a miembros protegidos 
   *  - Existencia de cdigo duplicado (if...)
   *  - Hemos de acordarnos de llamar al mtodo comprobar() de la clase Alarma
   */

  public void comprobar ()
  {
    super.comprobar();

    if (sensor.getValorActual()>umbral) {
       bombilla.encender();
    } else {
       bombilla.apagar();
    }
  }


}
